package codeshare.index;

import org.w3c.dom.Element;
import org.w3c.dom.Document;
import codeshare.index.util.SimpleTextIndexes;
import codeshare.index.util.SimpleTextIndex;
import java.util.List;
import java.util.Vector;

/**
 * @author James Snell (jasnell@us.ibm.com)
 */

public class Index extends DirectoryItem {

    protected SimpleTextIndexes indexes;
    
    public Index() {
        indexes = new SimpleTextIndexes();
        indexes.addIndex("Title", new SimpleTextIndex());
        indexes.addIndex("Creator", new SimpleTextIndex());
        indexes.addIndex("Subject", new SimpleTextIndex());
        indexes.addIndex("Description", new SimpleTextIndex());
    }
    
    public void addItem(Item item) {
        if (!(item instanceof ProjectItem))
            throw new IllegalArgumentException("Indexes can only contain Project items");
        ProjectItem project = (ProjectItem)item;
        project.index = this;
        if (items == null) items = new Vector();
        items.add(project);
        item.indexdc(indexes, project);
    }
    
    public List search(String index, String word) {
        return indexes.search(index, word);
    }
    
    public void serialize(Element parent) {
        Document doc = parent.getOwnerDocument();
        Element e = doc.createElement("codeShare");
        e.setAttribute("xmlns:dc", dcns);
        serializedc(e);
        serializeitems(e);
        parent.appendChild(e);
    }
    
    public void serialize(Document doc) {
        Element e = doc.createElement("codeShare");
        e.setAttribute("xmlns:dc", dcns);
        serializedc(e);
        serializeitems(e);
        doc.appendChild(e);
    }
   
}
