package codeshare.index;

import org.w3c.dom.Element;
import org.w3c.dom.Document;
import java.util.Vector;

/**
 * @author James Snell (jasnell@us.ibm.com)
 */

public class ProjectItem extends DirectoryItem {

    protected Index index;

    public void addItem(Item item) {
        if (item instanceof Index || item instanceof ProjectItem)
            throw new IllegalArgumentException("Projects and Indexes cannot be contained within projects");
        if (item instanceof DirectoryItem)
            ((DirectoryItem)item).project = this;
        if (items == null) items = new Vector();
        items.add(item);
        item.indexdc(index.indexes, this);
    }
    
    public void serialize(Element parent) {
        Document doc = parent.getOwnerDocument();
        Element e = doc.createElement("project");
        serializedc(e);
        serializeitems(e);
        parent.appendChild(e);
    }
    
    public String toString() {
        StringBuffer strbuf = new StringBuffer();
        strbuf.append("\nProject");
        toString(strbuf);
        return strbuf.toString();
    }
}
