package codeshare.index.util;

import java.io.FileWriter;
import codeshare.index.Index;
import org.w3c.dom.Document;
import org.apache.xml.serialize.XMLSerializer;
import org.apache.xml.serialize.OutputFormat;

/**
 * @author James Snell (jasnell@us.ibm.com)
 */

public class IndexWriter {

    public static synchronized boolean writeIndex(String path, Index index) {
        try {
            Document doc = XMLUtils.newDocument();
            index.serialize(doc);
            FileWriter fw = new FileWriter(path);
            OutputFormat of = new OutputFormat();
            of.setIndenting(true);
            XMLSerializer x = new XMLSerializer(fw, of);
            x.serialize(doc);
            fw.close();
            return true;
        } catch (Exception e) { return false; }
    }
    
}
