package codeshare.index.util;

import java.util.Map;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Enumeration;
import codeshare.index.ProjectItem;

/**
 * @author James Snell (jasnell@us.ibm.com)
 */

public class SimpleTextIndex {

    protected Map index = new HashMap();
    
    public List search(String word) {
        return (List)index.get(word.toLowerCase());
    }
    
    public void index(String value, ProjectItem project) {
        for (Enumeration e = tokenize(value); e.hasMoreElements();) {
            String s = (String)e.nextElement();
            if (!isJunk(s)) {
                System.out.println("Indexing.... " + s);
                List l = (List)index.get(s);
                if (l == null) {
                    l = new ArrayList();
                    index.put(s.toLowerCase(), l);
                }
                if (!(l.contains(project)))
                    l.add(project);
            }
        }
    }
    
    private Enumeration tokenize(String value) {
        StringTokenizer st = new StringTokenizer(value, " ", true);
        return st;
    }
    
    private boolean isJunk(String word) {
        if (word == null) return true;
        word = word.toLowerCase();
        return ( "the".equals(word) ||
                 "is".equals(word)  ||
                 "and".equals(word) ||
                 "a".equals(word)   ||
                 "i".equals(word)   ||
                 "my".equals(word)  ||
                 "to".equals(word)  ||
                 " ".equals(word)
                // add other junk words as appropriate
                );
    }
    
}
