package codeshare.index.util;

import java.util.Map;
import java.util.HashMap;
import java.util.List;
import codeshare.index.ProjectItem;
import codeshare.index.util.SimpleTextIndex;

/**
 * @author James Snell (jasnell@us.ibm.com)
 */

public class SimpleTextIndexes {

    protected Map indexes = new HashMap();
    
    public void addIndex(String name, SimpleTextIndex index) {
        indexes.put(name, index);
    }
    
    public SimpleTextIndex getIndex(String name) {
        return (SimpleTextIndex)indexes.get(name);
    }
    
    public List search(String name, String word) {
        SimpleTextIndex index = getIndex(name);
        if (index != null)
            return index.search(word);
        return null;
    }
    
    public void index(String name, String value, ProjectItem project) {
        SimpleTextIndex index = getIndex(name);
        if (index != null)
            index.index(value, project);
        return;
    }
}
