
import java.io.*;
import java.net.*;
import java.util.*;
import org.apache.soap.*;
import org.apache.soap.rpc.*;

public class Example1_client {

  public static void main (String[] args) throws Exception {

    if (args.length != 2
        && (args.length != 3 || !args[0].startsWith ("-"))) {
      System.err.println ("Usage: java " + Example1_client.class.getName () +
                          " [-encodingStyleURI] SOAP-router-URL Your-name");
      System.exit (1);
    }


    System.out.println("\n\nCalling the SOAP Server to say hello\n\n");


    int offset = 3 - args.length;
    String encodingStyleURI = args.length == 3
                              ? args[0].substring(1)
                              : Constants.NS_URI_SOAP_ENC;
    URL url = new URL (args[1 - offset]);
    String name = args[2 - offset];

    Call call = new Call ();
    call.setTargetObjectURI ("urn:Example1");
    call.setMethodName ("sayHello");
    call.setEncodingStyleURI(encodingStyleURI);
    Vector params = new Vector ();
    params.addElement (new Parameter("name", String.class, name, null));
    call.setParams (params);

    System.out.print("The SOAP Server says: ");

    Response resp = call.invoke (url, "");

    if (resp.generatedFault ()) {
      Fault fault = resp.getFault ();
      System.out.println ("\nOuch, the call failed: ");
      System.out.println ("  Fault Code   = " + fault.getFaultCode ());  
      System.out.println ("  Fault String = " + fault.getFaultString ());
    } else {
      Parameter result = resp.getReturnValue ();
      System.out.print(result.getValue ());
      System.out.println();
    }
  }
}